// iOS Dev Tutorial series on http://mobileorchard.com

#import "CalculatorViewController.h"

@implementation CalculatorViewController

-(IBAction)calculate {
	//Here we are creating two strings and assigning the value of the textfields to the strings.
	NSString *firstString = textfieldone.text;
	NSString *secondString = textfieldtwo.text;
	
	NSString *LEGAL = @"0123456789";
	NSCharacterSet *characterSet = [[NSCharacterSet characterSetWithCharactersInString:LEGAL] invertedSet];
    NSString *filteredOne = [[firstString componentsSeparatedByCharactersInSet:characterSet] 
						  componentsJoinedByString:@""];
	NSString *filteredTwo = [[secondString componentsSeparatedByCharactersInSet:characterSet] 
							 componentsJoinedByString:@""];
	firstString = filteredOne;
	secondString = filteredTwo;
	
	//Here we are creating three doubles
	double num1;
	double num2;
	double output;
	//Here we are assigning the values 
	num1 = [firstString doubleValue];
	num2 = [secondString doubleValue];
	//Now we are going to perform the action selected by the segmented control.
	//This checks to see if the selected index of the segmented control is 0 or +, if it is we perform the action.
	if (segmentedControl.selectedSegmentIndex == 0) {
		output = num1 + num2;
	}
	//This checks to see if the selected index of the segemented control is 1 or -, if it is we perform the action.
	if (segmentedControl.selectedSegmentIndex == 1) {
		output = num1 - num2;
	}
	//This checks to see if the selected index of the segemented control is 2 or *, if it is we perform the action.
	if (segmentedControl.selectedSegmentIndex == 2) {
		output = num1 * num2;
	}
	//This checks to see if the selected index of the segemented control is 3 or /, if it is we perform the action.
	if (segmentedControl.selectedSegmentIndex == 3) {
		//Here, we are checking to see if the divisor is zero. If it is, we display an error alert. If it isn't
		//we do the operation. 
		if (num2 == 0) {
	   UIAlertView *errorAlert = [[UIAlertView alloc] initWithTitle:@"Error" message:@"You cannot divide by zero." 
								delegate:self cancelButtonTitle:@"OK, I won't do it again"
									otherButtonTitles:nil];
			[errorAlert show];
			[errorAlert release];
		}
		else {
			output = num1 / num2;
		}
	}
	//Now we are going to display the output in the label.
	label.text = [NSString stringWithFormat:@"%f",output];
}
-(IBAction)closeKeyboard {
	//Here we are closing the keyboard for both of the textfields.
	[textfieldone resignFirstResponder];
	[textfieldtwo resignFirstResponder];
}
-(void)didReceiveMemoryWarning {
	// Releases the view if it doesn't have a superview.
    [super didReceiveMemoryWarning];
	
	// Release any cached data, images, etc that aren't in use.
}
-(void)viewDidUnload {
	// Release any retained subviews of the main view.
	// e.g. self.myOutlet = nil;
}
-(void)dealloc {
	//This release the decleration we made in the header file
	[textfieldone release];
	[textfieldtwo release];
	[label release];
	
    [super dealloc];
}

@end
